#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <ogcsys.h>
#include <gccore.h>
#include<time.h>

static void *xfb = NULL;
static GXRModeObj *rmode = NULL;

int pedir_tirada (char[][21], int[][21], int, int);
void mostrar_tablero (int[][21], char[][21], int, int, int, int);
void generar_tablero (char [][21], int[][21], int, int, int);
int procesar_tirada (char[][21], int[][21], int, int, int, int);
void recursividad (char[][21], int[][21], int, int, int, int);
int minas_restantes (char[][21], int[][21], int, int, int);



int main(int argc, char **argv) {

	VIDEO_Init();
	PAD_Init();
	
	switch(VIDEO_GetCurrentTvMode()) {
		case VI_NTSC:
			rmode = &TVNtsc480IntDf;
			break;
		case VI_PAL:
			rmode = &TVPal528IntDf;
			break;
		case VI_MPAL:
			rmode = &TVMpal480IntDf;
			break;
		default:
			rmode = &TVNtsc480IntDf;
			break;
	}

	xfb = MEM_K0_TO_K1(SYS_AllocateFramebuffer(rmode));
	console_init(xfb,20,20,rmode->fbWidth,rmode->xfbHeight,rmode->fbWidth*VI_DISPLAY_PIX_SZ);
	
	VIDEO_Configure(rmode);
	VIDEO_SetNextFramebuffer(xfb);
	VIDEO_SetBlack(FALSE);
	VIDEO_Flush();
	VIDEO_WaitVSync();
	if(rmode->viTVMode&VI_NON_INTERLACE) VIDEO_WaitVSync();

	while(1) {

		VIDEO_WaitVSync();
		int ronda_1=1, fin_partida=0, size_x, size_y, minas, N[21][21], datos_tirada=0;
	char M[21][21];


	printf("\n\nPara un correcto funcionamiento del juego debes maximizar la pantalla primero\n\n");

	do { printf("Introduce el numero de filas y columnas (max 20x20)\n");
        int aux=0, flag1=0, buttonsDown = 0;
        
        printf("\n%d\n",aux);
		while(flag1==0){
                       VIDEO_WaitVSync();
		               PAD_ScanPads();
		               buttonsDown = PAD_ButtonsDown(0);
		               if(buttonsDown & PAD_BUTTON_RIGHT){
		                              aux++;
		                              printf("%d\n",aux);
                                }
                       if(buttonsDown & PAD_BUTTON_LEFT){
                       aux--;
                       printf("%d\n",aux);
                       }
                       PAD_ScanPads();
                       buttonsDown = PAD_ButtonsDown(0);
                       if(buttonsDown & PAD_BUTTON_A){
                       flag1=1;
                       }
                       size_x=size_y=aux;
                       }            
	
    }
	while ((size_x<1)||(size_y>20)||(size_y<1)||(size_x>20));

	
	do { printf("Introduce el numero de minas\n");
	    int flag1=0, aux=0, buttonsDown = 0;
	    printf("\n%d\n",aux);	
		while(flag1==0){
                       VIDEO_WaitVSync();
		               PAD_ScanPads();
		               buttonsDown = PAD_ButtonsDown(0);
		               if(buttonsDown & PAD_BUTTON_RIGHT){
		                              aux++;
		                              printf("%d\n",aux);
                                }
                       if(buttonsDown & PAD_BUTTON_LEFT){
                       aux--;
                       printf("%d\n",aux);
                       }
                       PAD_ScanPads();
                       buttonsDown = PAD_ButtonsDown(0);
                       if(buttonsDown & PAD_BUTTON_A){
                       flag1=1;
                       }
                       minas=aux;
                       } 
    }
	while ((minas<1)||(minas>=(size_x)*(size_y)));
	
	generar_tablero(M,N,size_x,size_y,minas);

	do{
		if (ronda_1==1){ 
            VIDEO_Flush();                       
			mostrar_tablero(N,M,size_x,size_y,1,0);
			VIDEO_WaitVSync();
			ronda_1=0;
		}
	    	else{
			datos_tirada=(pedir_tirada(M,N,size_x, size_y));
			if(datos_tirada==1053){
				fin_partida=1;
			}
			VIDEO_Flush();
			mostrar_tablero(N,M,size_x,size_y,0,fin_partida);
			VIDEO_WaitVSync();
			if(minas_restantes(M,N,minas,size_x,size_y)==0)
				fin_partida=1;
		}
	}while(fin_partida==0);
/*Salidas*/

if (datos_tirada==1053){	/*codigo numerico, lose(perder)*/
	printf("Has perdido\n");
	getchar();
    getchar();}
else{
	printf("Has ganado\n");
	getchar();
    getchar();}
return(0);
}
}
void mostrar_tablero(int N[][21], char M[][21], int size_x, int size_y, int ronda_1, int fin_partida){

	/*Los contadores estan a 1 como posicion inicial porque la primera casilla es un 1, no un 0*/

	int i, j, cont;					/*filas, columnas, contador para tabular bien los indicadores*/

	for (i=1;i<=size_x;i++){
		if (i==1){
		printf("                   ");	/*tabulacion para centrar el vector indicaciones*/
		for (cont=1;cont<=size_y;cont++)			/*genera el vector de los indicadores*/
			if (cont>=10)					/*si pasa de 10 se deja un espacio menos*/
				printf("%d  ", cont);
				
			else
				printf("%d   ", cont);
		}

		printf("\n                 ");	/*tabulacion centrar tablero*/
		for(cont=1;cont<=size_y;cont++){
			printf("----");					/*detrminar la longitud de la linea separadora*/
		}
		printf("-\n");

		for (j=1;j<=size_y;j++){
			if (j==1){
				if (i>=10)
					printf("               %d ", i);
				else
					printf("               %d ", i);
				printf("| ");
			}
			else{
				printf(" | ");
			}
			if(fin_partida==1){
				if(M[i][j]=='d')
					printf(" ");
				else
					printf("%c",M[i][j]);
			}
			else{
				if(ronda_1==1)
					printf(" ");
				else{
					if(M[i][j]=='*')
						printf(" ");
					if(M[i][j]=='d')	
						printf("%d",N[i][j]);
					if(M[i][j]==' ')	
						printf(" ");
				}
			}			
			if(j==size_y)
				printf(" |");
		}
	}
	printf("\n                 ");
	for(cont=1;cont<=size_y;cont++){
		printf("----");
	}
	printf("-\n\n");

}




int pedir_tirada(char M[][21], int N[][21], int size_x, int size_y){

	int a, b;

	do {	printf("Selecciona coordenada x\n");
			int flag1=0, aux=0, buttonsDown = 0;
	    printf("\n%d\n",aux);	
		while(flag1==0){
                       VIDEO_WaitVSync();
		               PAD_ScanPads();
		               buttonsDown = PAD_ButtonsDown(0);
		               if(buttonsDown & PAD_BUTTON_RIGHT){
		                              aux++;
		                              printf("%d\n",aux);
                                }
                       if(buttonsDown & PAD_BUTTON_LEFT){
                       aux--;
                       printf("%d\n",aux);
                       }
                       PAD_ScanPads();
                       buttonsDown = PAD_ButtonsDown(0);
                       if(buttonsDown & PAD_BUTTON_A){
                       flag1=1;
                       }
                       a=aux;
                       } 
            }
	while ((a<1)||(a>size_x));
	
	do {	printf("Selecciona coordenada y\n");
			int flag1=0, aux=0, buttonsDown = 0;
	    printf("\n%d\n",aux);	
		while(flag1==0){
                       VIDEO_WaitVSync();
		               PAD_ScanPads();
		               buttonsDown = PAD_ButtonsDown(0);
		               if(buttonsDown & PAD_BUTTON_RIGHT){
		                              aux++;
		                              printf("%d\n",aux);
                                }
                       if(buttonsDown & PAD_BUTTON_LEFT){
                       aux--;
                       printf("%d\n",aux);
                       }
                       PAD_ScanPads();
                       buttonsDown = PAD_ButtonsDown(0);
                       if(buttonsDown & PAD_BUTTON_A){
                       flag1=1;
                       }
                       b=aux;
                       } 
            }
	while ((b<1)||(b>size_y));
	
	return(procesar_tirada(M,N,a,b,size_x,size_y));
}



void generar_tablero (char M[][21], int N[][21],int x, int y, int minas){

	int numi, numj, i, j, a, b, cont_minas=0;
	srand(time(NULL));

	for (i=0;i<=x;i++){				/*llenar todas las casillas de ceros, incluidos los margenes*/
		for (j=0;j<=y;j++){
			M[i][j]=' ';
			N[i][j]=0;
		}
	}


	for (i=0;i<minas;){	
		

		numi=rand() % x+1;			/*Se suma 1 para abarcar todo el tablero*/
		numj=rand() % y+1;
		if(M[numi][numj]!='*'){	/*Si no habia ya una bomba puesta, ponerla ahi*/
			M[numi][numj]='*';
			N[numi][numj]=9;			/*9 quiere decir que hay una bomba*/
			i++;	/*Se contabiliza si se ha puesto una mina correctamente*/
		}
		
	}
	
	/* "i" y "j" empiezan siendo 1 porque la primera casilla del tablero es la (1,1), no la (0,0)*/
	for (i=1;i<=x;i++){
		for (j=1;j<=y;j++){			/*Recorrer todo el tablero*/
			for(a=i-1;a<=i+1;a++){
				for(b=j-1;b<=j+1;b++){	/*Para cada casilla comprobar las adyacentes*/
					if(N[a][b]==9)
						cont_minas++;	/*Si hay minas contarlas*/
				}
			}
			if(N[i][j]!=9){		/*si en la casilla no habia mina poner el num. de minas que hay alrededor*/
				N[i][j]=cont_minas;
			}
			cont_minas=0;		/*resetear el contador de minas para la siguiente casilla*/
		}
	}
}



int procesar_tirada (char M[][21], int N[][21], int a, int b, int size_x, int size_y){

/*i y j son las coordenadas del objetivo, el punto a analizar en cada momento si hay mina o no, se empieza por las coordenadas dadas -1(de izquierda a derecha de arriba a abajo alrededor de las coord iniciales*/


	if(N[a][b]==9)
		return(1053);					/*Si hay mina manda mensaje de 1053 (lose)*/
	else{
		recursividad(M,N,a,b,size_x,size_y);				/*acabar esta parte con la funcion recursiva*/
		return(0);
	}
}


void recursividad (char M[][21], int N[][21], int a, int b, int size_x, int size_y){

	int i,j;
	
	if(N[a][b]==0){							/*si la que se analiza es 0...*/
		M[a][b]='d';						/*se destapa*/
		for(i=a-1;i<=a+1;i++){					/*se recorren las adyacentes*/
			for(j=b-1;j<=b+1;j++){
				if((M[i][j]!='d')&&(N[i][j]!=9)&&((i>0)||(i<size_x))&&((j>0)||(j<size_y))){	/*si la adyacente no esta destapada y no es mina..*/
					M[i][j]='d';			/*se destapa*/
					recursividad(M,N,i,j,size_x,size_y);		/*se repite el proceso en cada casilla adyacente*/
				}
			}
		}
	}
	else
		M[a][b]='d';						/*si no es 0 solo se destapa*/	
}


int minas_restantes (char M[][21], int N[][21], int minas, int x, int y){

	int cont=0, i, j;

	for(i=1;i<=x;i++){
		for(j=1;j<=y;j++){
			if(M[i][j]=='d')
				cont++;
		}
	}
	return((x*y)-(minas+cont));
}
